import { addUniqueItem, removeItem } from '../../utils/array.js';
import { sortByDepth } from './sort-by-depth.js';

var LayoutTree = /** @class */ (function () {
    function LayoutTree() {
        this.children = [];
        this.numChildren = 0;
        this.isDirty = false;
    }
    LayoutTree.prototype.add = function (child) {
        addUniqueItem(this.children, child);
        this.isDirty = true;
    };
    LayoutTree.prototype.remove = function (child) {
        removeItem(this.children, child);
        this.isDirty = true;
    };
    LayoutTree.prototype.forEach = function (callback) {
        this.isDirty && this.order();
        for (var i = 0; i < this.numChildren; i++) {
            callback(this.children[i]);
        }
    };
    LayoutTree.prototype.order = function () {
        this.children.sort(sortByDepth);
        this.numChildren = this.children.length;
    };
    return LayoutTree;
}());

export { LayoutTree };
